<?php
declare(strict_types=1);

namespace Inti\Elementor\Plugin;

use Inti\Wp\Plugin\PluginInterface;
use Psr\Container\ContainerInterface;

/**
 * Class RegisterCategoriesFactory
 *
 * @package Inti\Elementor\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-elementor
 */
final class RegisterCategoriesFactory
{
    public function __invoke(ContainerInterface $container): PluginInterface
    {
        $config = $container->has('config') ? $container->get('config') : [];
        return new RegisterCategories($config['elementor']['categories'] ?? []);
    }
}
