<?php
declare(strict_types=1);

namespace Inti\Elementor\Plugin;

use Elementor\Widgets_Manager;
use Inti\Wp\Plugin\PluginInterface;
use Laminas\ServiceManager\PluginManagerInterface;

/**
 * Class RegisterWidgets
 *
 * @package Inti\Elementor\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-elementor
 */
final class RegisterWidgets implements PluginInterface
{
    private PluginManagerInterface $widgetManager;
    /** @var string[] */
    private array $widgets;

    public function __construct(PluginManagerInterface $widgetManager, array $widgets)
    {
        $this->widgetManager = $widgetManager;
        $this->widgets = $widgets;
    }

    public function attachEarly(): void
    { }

    public function attach(): void
    {
        add_action('elementor/widgets/widgets_registered', [$this, 'widgets_registered']);
    }

    public function widgets_registered(Widgets_Manager $manager)
    {
        foreach ($this->widgets as $widget) {
            $manager->register_widget_type($this->widgetManager->get($widget));
        }
    }
}
