<?php
declare(strict_types=1);

namespace Inti\Elementor\Plugin;

use Inti\Elementor\Widget\WidgetPluginManager;
use Inti\Wp\Plugin\PluginInterface;
use Psr\Container\ContainerInterface;

/**
 * Class RegisterWidgetsFactory
 *
 * @package Inti\Elementor\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-elementor
 */
final class RegisterWidgetsFactory
{
    public function __invoke(ContainerInterface $container): PluginInterface
    {
        $config = $container->has('config') ? $container->get('config') : [];
        $widgetManager = $container->get(WidgetPluginManager::class);

        return new RegisterWidgets($widgetManager, $config['elementor']['widgets'] ?? []);
    }
}
